# coding: utf-8

"""
    Geometry Backend API v2

    The ShapeDiver Geometry Backend system is used to: * host Grasshopper models in a secure, reliable, scalable, and performant way, * run computations of Grasshopper models, * and cache and output the results of computations and exports.

    The version of the OpenAPI document: 2.13.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ResVisualizationType(str, Enum):
    """
    Optional preferred visualization for parameters of type `FILE` and `STRINGLIST`.
    """

    """
    allowed enum values
    """
    UNKNOWN = 'unknown'
    BUTTON = 'button'
    CALENDAR = 'calendar'
    CHECKLIST = 'checklist'
    CLOCK = 'clock'
    CYCLE = 'cycle'
    DIAL = 'dial'
    DROPDOWN = 'dropdown'
    GEOMETRY = 'geometry'
    IMAGE = 'image'
    SEQUENCE = 'sequence'
    SLIDER = 'slider'
    SWATCH = 'swatch'
    TEXT = 'text'
    TOGGLE = 'toggle'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ResVisualizationType from a JSON string"""
        return cls(json.loads(json_str))


